CLS
@ECHO OFF

@ECHO ------------------------: >> ..\log.txt
Date /t >> ..\log.txt
Time /t >> ..\log.txt
@ECHO ------------------------: >> ..\log.txt
 
if /I "%1" == "/F" goto Force

@ECHO ------------------------: "Check type of the backend_IC" >> ..\log.txt
@ECHO ------------------------: "Check type of the backend_IC"
FWv.0.2.exe /t:%2 /s > result.txt
if not %errorlevel% == 0 goto Err
@ECHO ------------------------: "%3" >> ..\log.txt
@ECHO ------------------------: "%3"

if /I "%7" == "/B" goto SkipIDrv

@ECHO ------------------------: "Check FW version presently" >> ..\log.txt
@ECHO ------------------------: "Check FW version presently"
ChkRev.exe %4 >> ..\log.txt
ChkRev.exe %4
if %errorlevel% == 1 goto I0C45Drv
ChkRev.exe %5 >> ..\log.txt
ChkRev.exe %5
if %errorlevel% == 1 goto I04F2Drv
@ECHO ------------------------: "Device didn't exist" >> ..\log.txt
@ECHO ------------------------: "Device didn't exist"
goto End
:I0C45Drv
@ECHO ------------------------: %4 >> ..\log.txt
@ECHO ------------------------: %4
@ECHO ------------------------: "Install FW burning driver"  >> ..\log.txt
@ECHO ------------------------: "Install FW burning driver"
if /I "%PROCESSOR_ARCHITECTURE%" == "X86" DrvInst32.exe install ".\Driver\st50220.inf" %4 > result.txt
if /I "%PROCESSOR_ARCHITECTURE%" == "AMD64" DrvInst64.exe install ".\Driver\st50220.inf" %4 > result.txt
if /I "%PROCESSOR_ARCHITECTURE%" == "X86" DPInst32.exe /sw /sa /lm /path .\Driver
if /I "%PROCESSOR_ARCHITECTURE%" == "AMD64" DPInst64.exe /sw /sa /lm /path .\Driver
if /I "%PROCESSOR_ARCHITECTURE%" == "X86" DrvInst32.exe disable %4 > result.txt
if /I "%PROCESSOR_ARCHITECTURE%" == "X86" _WaitDevicePlugIn.exe 5 "" ""
if /I "%PROCESSOR_ARCHITECTURE%" == "X86" DrvInst32.exe enable %4 > result.txt
if /I "%PROCESSOR_ARCHITECTURE%" == "X86" _WaitDevicePlugIn.exe 5 "" ""
if /I "%PROCESSOR_ARCHITECTURE%" == "AMD64" DrvInst64.exe disable %4 > result.txt
if /I "%PROCESSOR_ARCHITECTURE%" == "AMD64" _WaitDevicePlugIn.exe 5 "" ""
if /I "%PROCESSOR_ARCHITECTURE%" == "AMD64" DrvInst64.exe enable %4 > result.txt
if /I "%PROCESSOR_ARCHITECTURE%" == "AMD64" _WaitDevicePlugIn.exe 5 "" ""
set _DevID=0C45
goto SkipIDrv
:I04F2Drv
@ECHO ------------------------: %5 >> ..\log.txt
@ECHO ------------------------: %5
@ECHO ------------------------: "Install FW burning driver" >> ..\log.txt
@ECHO ------------------------: "Install FW burning driver"
if /I "%PROCESSOR_ARCHITECTURE%" == "X86" DrvInst32.exe install ".\Driver\st50220.inf" %5 > result.txt
if /I "%PROCESSOR_ARCHITECTURE%" == "AMD64" DrvInst64.exe install ".\Driver\st50220.inf" %5 > result.txt
if /I "%PROCESSOR_ARCHITECTURE%" == "X86" DPInst32.exe /sw /sa /lm /path .\Driver
if /I "%PROCESSOR_ARCHITECTURE%" == "AMD64" DPInst64.exe /sw /sa /lm /path .\Driver
if /I "%PROCESSOR_ARCHITECTURE%" == "X86" DrvInst32.exe disable %5 > result.txt
if /I "%PROCESSOR_ARCHITECTURE%" == "X86" _WaitDevicePlugIn.exe 5 "" ""
if /I "%PROCESSOR_ARCHITECTURE%" == "X86" DrvInst32.exe enable %5 > result.txt
if /I "%PROCESSOR_ARCHITECTURE%" == "X86" _WaitDevicePlugIn.exe 5 "" ""
if /I "%PROCESSOR_ARCHITECTURE%" == "AMD64" DrvInst64.exe disable %5 > result.txt
if /I "%PROCESSOR_ARCHITECTURE%" == "AMD64" _WaitDevicePlugIn.exe 5 "" ""
if /I "%PROCESSOR_ARCHITECTURE%" == "AMD64" DrvInst64.exe enable %5 > result.txt
if /I "%PROCESSOR_ARCHITECTURE%" == "AMD64" _WaitDevicePlugIn.exe 5 "" ""
set _DevID=04F2

:SkipIDrv
_WaitDevicePlugIn.exe 1 "" ""
:Force
FWv.0.2.exe /e /s > result.txt
@ECHO ------------------------: "Erase serial flash" >> ..\log.txt
@ECHO ------------------------: "Erase serial flash"

FWv.0.2.exe /c:0000~1fff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Check erasion 12%%" >> ..\log.txt
@ECHO ------------------------: "Check erasion 12%%"
FWv.0.2.exe /c:2000~3fff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Check erasion 25%%" >> ..\log.txt
@ECHO ------------------------: "Check erasion 25%%"
FWv.0.2.exe /c:4000~5fff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Check erasion 37%%" >> ..\log.txt
@ECHO ------------------------: "Check erasion 37%%"
FWv.0.2.exe /c:6000~7fff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Check erasion 50%%" >> ..\log.txt
@ECHO ------------------------: "Check erasion 50%%"
FWv.0.2.exe /c:8000~9fff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Check erasion 62%%" >> ..\log.txt
@ECHO ------------------------: "Check erasion 62%%"
FWv.0.2.exe /c:a000~bfff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Check erasion 75%%" >> ..\log.txt
@ECHO ------------------------: "Check erasion 75%%"
FWv.0.2.exe /c:c000~dfff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Check erasion 87%%" >> ..\log.txt
@ECHO ------------------------: "Check erasion 87%%"
FWv.0.2.exe /c:e000~ffff /s > result.txt
if not %errorlevel% == 0 goto Err
@ECHO ------------------------: "Check erasion 100%%" >> ..\log.txt
@ECHO ------------------------: "Check erasion 100%%"

FWv.0.2.exe /w:0040~1fff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Write in ... 12%%" >> ..\log.txt
@ECHO ------------------------: "Write in ... 12%%"
FWv.0.2.exe /w:2000~3fff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Write in ... 25%%" >> ..\log.txt
@ECHO ------------------------: "Write in ... 25%%"
FWv.0.2.exe /w:4000~5fff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Write in ... 37%%" >> ..\log.txt
@ECHO ------------------------: "Write in ... 37%%"
FWv.0.2.exe /w:6000~7fff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Write in ... 50%%" >> ..\log.txt
@ECHO ------------------------: "Write in ... 50%%"
FWv.0.2.exe /w:8800~9fff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Write in ... 62%%" >> ..\log.txt
@ECHO ------------------------: "Write in ... 62%%"
FWv.0.2.exe /w:a000~bfff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Write in ... 75%%" >> ..\log.txt
@ECHO ------------------------: "Write in ... 75%%"
FWv.0.2.exe /w:c000~dfff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Write in ... 87%%" >> ..\log.txt
@ECHO ------------------------: "Write in ... 87%%"
FWv.0.2.exe /w:e000~ffff /s > result.txt
if not %errorlevel% == 0 goto Err
@ECHO ------------------------: "Write in ... 100%%" >> ..\log.txt
@ECHO ------------------------: "Write in ... 100%%"

FWv.0.2.exe /v:0040~1fff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Verify code 12%%" >> ..\log.txt
@ECHO ------------------------: "Verify code 12%%"
FWv.0.2.exe /v:2000~3fff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Verify code 25%%" >> ..\log.txt
@ECHO ------------------------: "Verify code 25%%"
FWv.0.2.exe /v:4000~5fff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Verify code 37%%" >> ..\log.txt
@ECHO ------------------------: "Verify code 37%%"
FWv.0.2.exe /v:6000~7fff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Verify code 50%%" >> ..\log.txt
@ECHO ------------------------: "Verify code 50%%"
FWv.0.2.exe /v:8800~9fff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Verify code 62%%" >> ..\log.txt
@ECHO ------------------------: "Verify code 62%%"
FWv.0.2.exe /v:a000~bfff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Verify code 75%%" >> ..\log.txt
@ECHO ------------------------: "Verify code 75%%"
FWv.0.2.exe /v:c000~dfff /s > result.txt
if not %errorlevel% == 0 goto Err
REM @ECHO ------------------------: "Verify code 87%%" >> ..\log.txt
@ECHO ------------------------: "Verify code 87%%"
FWv.0.2.exe /v:e000~ffff /s > result.txt
if not %errorlevel% == 0 goto Err
@ECHO ------------------------: "Verify code 100%%" >> ..\log.txt
@ECHO ------------------------: "Verify code 100%%"

FWv.0.2.exe /w:8000~87ff /s > result.txt
if not %errorlevel% == 0 goto Err
@ECHO ------------------------: "Write parameter" >> ..\log.txt
@ECHO ------------------------: "Write parameter"
FWv.0.2.exe /v:8000~87ff /s > result.txt
if not %errorlevel% == 0 goto Err
@ECHO ------------------------: "Verify parameter" >> ..\log.txt
@ECHO ------------------------: "Verify parameter"

FWv.0.2.exe /w:0000~003f /s > result.txt
if not %errorlevel% == 0 goto Err
@ECHO ------------------------: "Write mark" >> ..\log.txt
@ECHO ------------------------: "Write mark"
FWv.0.2.exe /v:0000~003f /s > result.txt | CLS
if not %errorlevel% == 0 goto Err
@ECHO ------------------------: "Uninstall FW burning driver" >> ..\log.txt
@ECHO ------------------------: "Uninstall FW burning driver"
if /I "%PROCESSOR_ARCHITECTURE%" == "X86" DPInst32.exe /s /sh /u .\Driver\st50220.inf
if /I "%PROCESSOR_ARCHITECTURE%" == "AMD64" DPInst64.exe /s /sh /u .\Driver\st50220.inf
@ECHO ------------------------: "%3" >> ..\log.txt
@ECHO ------------------------: "%3"
@ECHO ------------------------: "Update successfully." (%6) >> ..\log.txt
@ECHO ------------------------: "Update successfully." (%6)
@ECHO ------------------------: "Please restart PC" >> ..\log.txt
@ECHO ------------------------: "Please restart PC"
goto End

:Err
set _DevID=xxxx
if %errorlevel% == 6 goto ErrMsg6
if %errorlevel% == 5 goto ErrMsg5
if %errorlevel% == 4 goto ErrMsg4
if %errorlevel% == 3 goto ErrMsg3
if %errorlevel% == 2 goto ErrMsg2
if %errorlevel% == 1 goto ErrMsg1
:ErrMsg1
@ECHO ------------------------: "Uninstall FW burning driver" >> ..\log.txt
@ECHO ------------------------: "Uninstall FW burning driver"
@ECHO ------------------------: "Camera init failed : ErrorCode = " %errorlevel% >> ..\log.txt
@ECHO ------------------------: "Camera init failed : ErrorCode = " %errorlevel%
if /I "%PROCESSOR_ARCHITECTURE%" == "X86" DPInst32.exe /s /sh /u .\Driver\st50220.inf
if /I "%PROCESSOR_ARCHITECTURE%" == "AMD64" DPInst64.exe /s /sh /u .\Driver\st50220.inf
@ECHO ------------------------: "Please try again after restart PC" >> ..\log.txt
@ECHO ------------------------: "Please try again after restart PC"
goto End
:ErrMsg2
@ECHO ------------------------: "Uninstall FW burning driver" >> ..\log.txt
@ECHO ------------------------: "Uninstall FW burning driver"
@ECHO ------------------------: "Erase fail : ErrorCode = " %errorlevel% >> ..\log.txt
@ECHO ------------------------: "Erase fail : ErrorCode = " %errorlevel%
if /I "%PROCESSOR_ARCHITECTURE%" == "X86" DPInst32.exe /s /sh /u .\Driver\st50220.inf
if /I "%PROCESSOR_ARCHITECTURE%" == "AMD64" DPInst64.exe /s /sh /u .\Driver\st50220.inf
@ECHO ------------------------: "Please try again after restart PC" >> ..\log.txt
@ECHO ------------------------: "Please try again after restart PC"
goto End
:ErrMsg3
@ECHO ------------------------: "Uninstall FW burning driver" >> ..\log.txt
@ECHO ------------------------: "Uninstall FW burning driver"
@ECHO ------------------------: "Request fail : ErrorCode = " %errorlevel% >> ..\log.txt
@ECHO ------------------------: "Request fail : ErrorCode = " %errorlevel%
if /I "%PROCESSOR_ARCHITECTURE%" == "X86" DPInst32.exe /s /sh /u .\Driver\st50220.inf
if /I "%PROCESSOR_ARCHITECTURE%" == "AMD64" DPInst64.exe /s /sh /u .\Driver\st50220.inf
@ECHO ------------------------: "Please try again after restart PC" >> ..\log.txt
@ECHO ------------------------: "Please try again after restart PC"
goto End
:ErrMsg4
@ECHO ------------------------: "Uninstall FW burning driver" >> ..\log.txt
@ECHO ------------------------: "Uninstall FW burning driver"
@ECHO ------------------------: "Verify fail : ErrorCode = " %errorlevel% >> ..\log.txt
@ECHO ------------------------: "Verify fail : ErrorCode = " %errorlevel%
if /I "%PROCESSOR_ARCHITECTURE%" == "X86" DPInst32.exe /s /sh /u .\Driver\st50220.inf
if /I "%PROCESSOR_ARCHITECTURE%" == "AMD64" DPInst64.exe /s /sh /u .\Driver\st50220.inf
@ECHO ------------------------: "Please try again after restart PC" >> ..\log.txt
@ECHO ------------------------: "Please try again after restart PC"
goto End
:ErrMsg5
@ECHO ------------------------: "Uninstall FW burning driver" >> ..\log.txt
@ECHO ------------------------: "Uninstall FW burning driver"
@ECHO ------------------------: "Load file fail : ErrorCode = " %errorlevel% >> ..\log.txt
@ECHO ------------------------: "Load file fail : ErrorCode = " %errorlevel% 
if /I "%PROCESSOR_ARCHITECTURE%" == "X86" DPInst32.exe /s /sh /u .\Driver\st50220.inf
if /I "%PROCESSOR_ARCHITECTURE%" == "AMD64" DPInst64.exe /s /sh /u .\Driver\st50220.inf
@ECHO ------------------------: "Please try again after restart PC" >> ..\log.txt
@ECHO ------------------------: "Please try again after restart PC"
goto End
:ErrMsg6
@ECHO ------------------------: "Uninstall FW burning driver" >> ..\log.txt
@ECHO ------------------------: "Uninstall FW burning driver"
@ECHO ------------------------: "Incorrect type of backend_IC : ErrorCode = " %errorlevel% >> ..\log.txt
@ECHO ------------------------: "Incorrect type of backend_IC : ErrorCode = " %errorlevel%
if /I "%PROCESSOR_ARCHITECTURE%" == "X86" DPInst32.exe /s /sh /u .\Driver\st50220.inf
if /I "%PROCESSOR_ARCHITECTURE%" == "AMD64" DPInst64.exe /s /sh /u .\Driver\st50220.inf
@ECHO ------------------------: "Please check type of the backend_IC via CheckType.bat" >> ..\log.txt
@ECHO ------------------------: "Please check type of the backend_IC via CheckType.bat"
:End

:SkipRDrv

CD..
PAUSE